## mit-scheme 12.1

=== dist/Makefile ===
# Copyright (C) 1986, 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994,
#     1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004,
#     2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014,
#     2015, 2016, 2017, 2018, 2019, 2020, 2021, 2022 Massachusetts
#     Institute of Technology
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA.

SUBDIRS = doc src

all:
	@for SUBDIR in $(SUBDIRS); do \
	    echo "Making $@ in $${SUBDIR}";\
	    ( cd $${SUBDIR}; $(MAKE) $@ ) || exit 1;\
	done

mostlyclean clean distclean maintainer-clean tags TAGS install:
	@for SUBDIR in $(SUBDIRS); do \
	    echo "Making $@ in $${SUBDIR}";\
	    ( cd $${SUBDIR}; $(MAKE) $@ ) || exit 1;\
	done

install-info-gz install-info install-html install-pdf install-ps:
	echo "making $@ in doc"
	( cd doc && $(MAKE) $@ )

.PHONY: all mostlyclean clean distclean maintainer-clean tags TAGS install
.PHONY: install-info-gz install-info install-html install-pdf install-ps

=== v8/src/compiler/Makefile ===
#
# Makefile for Scheme compiler
# This makefile supports some utilities for the compiler.
# The compiler provides its own tools for rebuilding itself,
# written in Scheme.
#

SOURCES = back/foo base/foo machine/foo midend/foo rtlbase/foo rtlopt/foo
SUBDIRS = $(SOURCES:foo=)

SHELL = /bin/sh

all:
	echo "No ALL action"

tags:
	etags back/*.scm base/*.scm \
	machines/*/*.scm midend/*.scm rtlbase/*.scm rtlopt/*.scm

index:
	rm -f INDEX
	/zu/cph/bin/schndx $(SOURCES:foo=*.scm) > INDEX

listing:
	prlist comp.pkg $(SOURCES:foo=*.scm)

locked:
	for subdir in . back base midend rtlbase rtlopt machines/*; \
	do \
	rlog -L -R $${subdir}/RCS/*,v ; \
	done

stage1:
	for subdir in $(SUBDIRS); \
	do \
	( cd $$subdir ; echo "making $$subdir" ; \
	mkdir STAGE1 ; mv *.com *.bci STAGE1/. ) \
	done

unstage1:
	for subdir in $(SUBDIRS); \
	do \
	( cd $$subdir ; echo "making $$subdir" ; \
	mv STAGE1/* . ; rmdir STAGE1 ) \
	done

rmstage1:
	rm -rf $(SOURCES:foo=STAGE1)

cpstage1:
	for subdir in $(SUBDIRS); \
	do \
	( cd $$subdir ; echo "making $$subdir" ; \
	cpx STAGE1/* . ) \
	done

lnstage1:
	for subdir in $(SUBDIRS); \
	do \
	( cd $$subdir ; echo "making $$subdir" ; \
	ln STAGE1/* . ) \
	done

stage2:
	for subdir in $(SUBDIRS); \
	do \
	( cd $$subdir ; echo "making $$subdir" ; \
	mkdir STAGE2 ; mv *.com *.bci STAGE2/. ) \
	done

unstage2:
	for subdir in $(SUBDIRS); \
	do \
	( cd $$subdir ; echo "making $$subdir" ; \
	mv STAGE2/* . ; rmdir STAGE2 ) \
	done

rmstage2:
	rm -rf $(SOURCES:foo=STAGE2)

cpstage2:
	for subdir in $(SUBDIRS); \
	do \
	( cd $$subdir ; echo "making $$subdir" ; \
	cpx STAGE2/* . ) \
	done

lnstage2:
	for subdir in $(SUBDIRS); \
	do \
	( cd $$subdir ; echo "making $$subdir" ; \
	ln STAGE2/* . ) \
	done

stage3:
	for subdir in $(SUBDIRS); \
	do \
	( cd $$subdir ; echo "making $$subdir" ; \
	mkdir STAGE3 ; mv *.com *.bci STAGE3/. ) \
	done

unstage3:
	for subdir in $(SUBDIRS); \
	do \
	( cd $$subdir ; echo "making $$subdir" ; \
	mv STAGE3/* . ; rmdir STAGE3 ) \
	done

rmstage3:
	rm -rf $(SOURCES:foo=STAGE3)

cpstage3:
	for subdir in $(SUBDIRS); \
	do \
	( cd $$subdir ; echo "making $$subdir" ; \
	cpx STAGE3/* . ) \
	done

lnstage3:
	for subdir in $(SUBDIRS); \
	do \
	( cd $$subdir ; echo "making $$subdir" ; \
	ln STAGE3/* . ) \
	done

=== debian/changelog ===
mit-scheme (12.1-3) unstable; urgency=medium

  * build dependency for pkg-config

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 11 Jan 2023 19:53:07 +0000

mit-scheme (12.1-2) unstable; urgency=medium

  [ Barak A. Pearlmutter ]
  * enable blowfish, gdbm, and pgsql (build dependency on libpq-dev)
  [ Debian Janitor ]
  * Remove constraints unnecessary since buster:
    + Build-Depends: Drop versioned constraint on mit-scheme.
    + mit-scheme-dbg: Drop versioned constraint on mit-scheme in Replaces.
    + mit-scheme-dbg: Drop versioned constraint on mit-scheme in Breaks.
    + mit-scheme-doc: Drop versioned constraint on mit-scheme in Replaces.
    + mit-scheme-doc: Drop versioned constraint on mit-scheme in Breaks.

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 10 Jan 2023 21:56:01 +0000

mit-scheme (12.1-1) unstable; urgency=medium

  * New upstream release
  * Forward port quilt patches; delete two that have been upstreamed
  * Update standards version to 4.6.2, no changes needed.

 -- Barak A. Pearlmutter <bap@debian.org>  Sat, 07 Jan 2023 16:58:36 +0000

mit-scheme (11.2-4) unstable; urgency=medium

  * replace dependency mime-support with media-types (closes: #1010101)

 -- Barak A. Pearlmutter <bap@debian.org>  Sun, 24 Apr 2022 16:52:20 +0100

mit-scheme (11.2-3) unstable; urgency=medium

  [ Nick Rosbrook ]
  * d/p/0001-microcode-Make-definition-for-chacha_core-match-decl.patch:
    Pull in upstream patch to fix -Werror=array-parameter build error.
    (LP: #1965163).

  [ Barak A. Pearlmutter ]
  * Spelling correction in description
  * Ubuntu OpenSSL 3.0 FTBFS patch (closes: #1006507)

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 21 Mar 2022 16:31:37 +0000

=== debian/control ===
Source: mit-scheme
Section: lisp
Priority: optional
Maintainer: Barak A. Pearlmutter <bap@debian.org>
Build-Depends: debhelper-compat (= 13),
		mit-scheme,
		libssl-dev, libmhash-dev, libmcrypt-dev,
		libgdbm-dev, libpq-dev,
		libncurses5-dev,
		libx11-dev, libxt-dev,
		libdb-dev, libltdl-dev,
		libpq-dev, pkgconf | pkg-config,
		texinfo, texlive, ghostscript, texlive-plain-generic
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://www.gnu.org/software/mit-scheme/
Vcs-Git: https://salsa.debian.org/debian/mit-scheme.git
Vcs-Browser: https://salsa.debian.org/debian/mit-scheme

Package: mit-scheme
Architecture: amd64
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: media-types
Suggests: mit-scheme-dbg, mit-scheme-doc
Description: MIT/GNU Scheme development environment
 MIT/GNU Scheme is an implementation of the Scheme programming language,
 providing an interpreter, compiler, source-code debugger, integrated
 Emacs-like editor, and a large runtime library.  MIT/GNU Scheme is best
 suited to programming large applications with a rapid development
 cycle.
 .
 This package contains the development environment.

Package: mit-scheme-dbg
Section: debug
Architecture: amd64
Multi-Arch: same
Depends: mit-scheme (= ${binary:Version}), ${misc:Depends}
Enhances: mit-scheme (= ${binary:Version})
Description: MIT/GNU Scheme debugging files
 MIT/GNU Scheme is an implementation of the Scheme programming language,
 providing an interpreter, compiler, source-code debugger, integrated
 Emacs-like editor, and a large runtime library.  MIT/GNU Scheme is best
 suited to programming large applications with a rapid development
 cycle.
 .
 This package contains debugging files for the development
 environment.  These files provide support for debugging the MIT/GNU
 Scheme system, and are useful only if you need to see the system
 internals while you are debugging.

Package: mit-scheme-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Enhances: mit-scheme (= ${binary:Version})
Description: MIT/GNU Scheme documentation
 MIT/GNU Scheme is an implementation of the Scheme programming language,
 providing an interpreter, compiler, source-code debugger, integrated
 Emacs-like editor, and a large runtime library.  MIT/GNU Scheme is best
 suited to programming large applications with a rapid development
 cycle.
 .
 This package contains documentation in Info, HTML, and PDF formats.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# for DEB_HOST_GNU_CPU
include /usr/share/dpkg/architecture.mk
# for DEB_VERSION_UPSTREAM
include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Passing --no-parallel because of some creepy race conditions, like
# on building x11-compat which can get built twice and if the second
# build happens at just the wrong time it interferes with the first
# build or with an invocation of the generated executable.

%:
	dh $@ --no-parallel

override_dh_autoreconf:
	dh_autoreconf sh -- -e -x -c \
	  'for d in src doc; \
	    do (cd $$d && autoreconf -f -i) done'

CONF_FLAGS += --docdir=/usr/share/doc/mit-scheme-doc
CONF_FLAGS += --enable-html=/usr/share/doc/mit-scheme-doc/html
CONF_FLAGS += --enable-pdf=/usr/share/doc/mit-scheme-doc/pdf
CONF_FLAGS += --enable-ps=no

CONF_FLAGS += --enable-blowfish=yes
CONF_FLAGS += --enable-gdbm=yes
CONF_FLAGS += --enable-pgsql=yes

# According to https://savannah.gnu.org/support/?110264 a build error like
#
#  Bad compiled-code version in FASL File: make.com
#  File has: compiled-code interface 3; architecture 14.
#  Expected: compiled-code interface 4; architecture 14.
#
# can occur when, e.g., 10.1.11 is installed but 11.1 is being built.
# And can be prevented using a configuration flag.

INSTALLED_MAJOR_VERSION:=$(shell dpkg --status mit-scheme | egrep '^Version:' | sed 's/^Version: //' | cut --delimiter=. --fields=1)
BUILDING_MAJOR_VERSION:=$(shell echo $(DEB_VERSION_UPSTREAM) | cut --delimiter=. --fields=1)
ifneq ($(INSTALLED_MAJOR_VERSION),$(BUILDING_MAJOR_VERSION))
CONF_FLAGS += --enable-cross-compiling
endif

override_dh_auto_configure:
# -arch
	dh_auto_configure --sourcedirectory=src -- $(CONF_FLAGS)
# -indep
	dh_auto_configure --sourcedirectory=doc -- $(CONF_FLAGS)

# May wish to pass parameter in dh_auto_build
#  SCHEME_COMPILER=mit-scheme

override_dh_auto_build:
# -arch
	dh_auto_build --sourcedirectory=src
# -indep
	dh_auto_build --sourcedirectory=doc

ifeq ($(DEB_HOST_GNU_CPU),x86_64)
export BIN_ARCH=x86-64
else
export BIN_ARCH=$(DEB_HOST_GNU_CPU)
endif

override_dh_auto_install:
# -arch
	dh_auto_install --sourcedirectory=src
# -indep
#	# This doesn't work because doc/ hasn't been *configured*
#	# which hardly seems worth working around
#	dh_auto_install --sourcedirectory=doc -- install-man
	dh_auto_install --sourcedirectory=doc -- install-html install-pdf

execute_after_dh_auto_install:
# -arch
	@echo "remove symbolic link executables"
	cd debian/tmp/usr/bin && \
	for f in scheme bchscheme mit-scheme mit-scheme-native; do \
	  if [ -L $$f ]; then \
	    rm --verbose -f $$f; \
	  else \
	    echo skipping $$f; \
	  fi; \
	done
#	@echo "delete runtime.com for MYSTERIOUS reasons"
#	@echo "stop doing this because it breaks future builds"
#	find debian/tmp/usr/lib -name runtime.com -ls -delete
	@echo "remove .la library support files as these are not actually used by the dynamic linker"
	find debian/tmp -name '*.la' -ls -delete
	@echo "allow dh scripts to compress info files themselves"
	find debian/tmp \( -name '*.info.gz' -o -name '*.info-*.gz' \) -ls -exec gunzip '{}' ';'

execute_after_dh_install-arch:
	@echo "All .bci files belong in -dbg, move them manually for robustness"
	mkdir -p debian/mit-scheme-dbg
	tar -C debian/mit-scheme --create --file=- --files-from=/dev/null $$(cd debian/mit-scheme && find -name '*.bci') \
	 | tar -C debian/mit-scheme-dbg -xvf -
	find debian/mit-scheme -name '*.bci' -delete
	@echo "remove empty directory"
	-rmdir debian/mit-scheme/usr/lib/x86_64-linux-gnu/mit-scheme/lib

execute_after_dh_installman-arch:
	@echo "install man page using arch; generic is via alternatives"
	cd debian/mit-scheme/usr/share/man && \
	 mv man1/mit-scheme.1 man1/mit-scheme-$(BIN_ARCH).1

# Upstream changelog is over 5MB, leave a copy in the doc package but
# remove it from the binary package to reduce bloat.
# See http://dedup.debian.net/.
override_dh_installchangelogs-arch:
	dh_installchangelogs
	-rm --verbose \
	   debian/mit-scheme/usr/share/doc/mit-scheme/changelog \
	   debian/mit-scheme-dbg/usr/share/doc/mit-scheme-dbg/changelog

override_dh_auto_clean:
	-dh_auto_clean
